-- Experimental homing version!

function Create(self)
	self.mapwrapx = SceneMan.SceneWrapsX;
	self.triggerTimer = Timer();
	self.lifeTimer = Timer();
	self.targetTimer = Timer();

	self.turnsharpness = 0.5;
	self.halfPi = math.pi*0.5;

	self.triggerTime = 250;
	self.missileLifeTime = 5000;
	self.targetSearchDelay = 100;
	self.detectRange = 500;

end

function Update(self)

	if self.triggerTimer.ElapsedSimTimeMS >= self.triggerTime then

		self:EnableEmission(true);

		if MovableMan:IsActor(self.target) then

			local targetPosition = self.target.Pos;

			if self.target.Vel.Magnitude > 5 then
				local time = SceneMan:ShortestDistance(self.Pos,self.target.Pos,self.mapwrapx).Magnitude / self.Vel.Magnitude;

				local endPoint = Vector(self.target.Vel.Magnitude*time,0):RadRotate(self.target.Vel.AbsRadAngle);
				local distance = endPoint.Magnitude;
				local dotSpacing = 5;
				local dots = distance/dotSpacing;

				for i = 1, dots do
					local checkPos = self.target.Pos + Vector(endPoint.X,endPoint.Y):SetMagnitude((i/dots)*distance);
					if SceneMan.SceneWrapsX == true then
						if checkPos.X > SceneMan.SceneWidth then
							checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
						elseif checkPos.X < 0 then
							checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
						end
					end
					local terrCheck = SceneMan:GetTerrMatter(checkPos.X,checkPos.Y);
					if terrCheck == 0 then
						targetPosition = checkPos;
					else
						break;
					end
				end
			end

			local aimVector = SceneMan:ShortestDistance(self.Pos,targetPosition,self.mapwrapx);

			local angleCheck = ((aimVector.AbsRadAngle-self.Vel.AbsRadAngle)*self.turnsharpness);
			if math.abs(angleCheck) > self.halfPi then
				self.RotAngle = self.Vel.AbsRadAngle + (self.halfPi*(-1));
			else
				self.RotAngle = aimVector.AbsRadAngle + angleCheck;
			end

		elseif not(MovableMan:IsActor(self.target)) and self.targetTimer:IsPastSimMS(self.targetSearchDelay) then
			self.targetTimer:Reset();

			for actor in MovableMan.Actors do
				if actor.Team ~= self.Team then
					self.potentialtargetdist = SceneMan:ShortestDistance(self.Pos,actor.Pos,self.mapwrapx);
					self.terrcheck = Vector(0,0);
					if (self.lastdist == nil or (self.lastdist ~= nil and self.potentialtargetdist.Magnitude < self.lastdist)) and self.potentialtargetdist.Magnitude <= self.detectRange and SceneMan:CastStrengthRay(self.Pos,self.potentialtargetdist:SetMagnitude(self.potentialtargetdist.Magnitude-actor.Radius),0,self.terrcheck,5,0,self.mapwrapx) == false then
						self.lastdist = self.potentialtargetdist.Magnitude;
						self.target = actor;
						self.lasttargetpos = Vector(self.target.Pos.X,self.target.Pos.Y);
					end
				end
			end

		end

	end

end
